<?php
error_reporting(E_ALL ^ E_NOTICE);
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST, PUT, GET, DELETE, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");

// Si la solicitud es de tipo OPTIONS, responde con los encabezados CORS y termina la ejecución
if ($_SERVER['REQUEST_METHOD'] === 'OPTIONS') {
    header("HTTP/1.1 200 OK");
    exit;
}

// Captura los valores de los parámetros desde la solicitud
//$token = isset($_GET['token']) ? $_GET['token'] : '';
$token = 'apis-token-7559.cD3uYFGUw-Lz0DD7r7qs-RgAW2CqPEFY';
$dni = isset($_GET['dni']) ? $_GET['dni'] : '';

// Verifica que se hayan proporcionado el token y el DNI
if (empty($token) || empty($dni)) {
    http_response_code(400);
    echo json_encode(array("message" => "Token y DNI son obligatorios."));
    exit;
}

// Iniciar llamada a API
$curl = curl_init();

// Construir la URL de la API con los parámetros dinámicos
$url = 'https://api.apis.net.pe/v2/reniec/dni?numero=' . $dni;

curl_setopt_array($curl, array(
    CURLOPT_URL => $url,
    CURLOPT_RETURNTRANSFER => true,
    CURLOPT_SSL_VERIFYPEER => 0,
    CURLOPT_ENCODING => '',
    CURLOPT_MAXREDIRS => 2,
    CURLOPT_TIMEOUT => 0,
    CURLOPT_FOLLOWLOCATION => true,
    CURLOPT_CUSTOMREQUEST => 'GET',
    CURLOPT_HTTPHEADER => array(
        'Referer: https://apis.net.pe/consulta-dni-api',
        'Authorization: Bearer ' . $token
    ),
));

$response = curl_exec($curl);

curl_close($curl);

// Datos de la persona según el DNI
$persona = json_decode($response);

if ($persona === null) {
    // Si hay un error en la respuesta de la API, devuelve un mensaje de error
    http_response_code(500);
    echo json_encode(array("message" => "Error en la llamada a la API."));
    exit;
}

// Devuelve la respuesta de la API como JSON
header('Content-Type: application/json');
echo json_encode($persona);

?>
