<?php

error_reporting(E_ALL ^ E_NOTICE);

header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST, PUT, GET, DELETE, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");

// Si la solicitud es de tipo OPTIONS, responde con los encabezados CORS y termina la ejecución
if ($_SERVER['REQUEST_METHOD'] === 'OPTIONS') {
    header("HTTP/1.1 200 OK");
    exit;
}

// Obtener el token desde los parámetros de la URL
$token ='apis-token-7561.7Kxj1BVGkbaVgG75IloVfmwBFZy0wHp5';

if (empty($token)) {
    // Si no se proporciona un token, devuelve un error
    http_response_code(401);
    echo json_encode(array("message" => "Token no proporcionado."));
    exit;
}

// Obtener el número de RUC desde los parámetros de la URL
$ruc = isset($_GET['ruc']) ? $_GET['ruc'] : '';

if (empty($ruc)) {
    // Si no se proporciona un número de RUC, devuelve un error
    http_response_code(400);
    echo json_encode(array("message" => "Número de RUC no proporcionado."));
    exit;
}

// Iniciar llamada a API
$curl = curl_init();

// Modificar la URL para incluir el token y el número de RUC como parámetros
$url = 'https://api.apis.net.pe/v2/sunat/ruc?numero=' . $ruc;
curl_setopt_array($curl, array(
  CURLOPT_URL => $url,
  CURLOPT_RETURNTRANSFER => true,
  CURLOPT_SSL_VERIFYPEER => 0,
  CURLOPT_ENCODING => '',
  CURLOPT_MAXREDIRS => 10,
  CURLOPT_TIMEOUT => 0,
  CURLOPT_FOLLOWLOCATION => true,
  CURLOPT_CUSTOMREQUEST => 'GET',
  CURLOPT_HTTPHEADER => array(
    'Referer: http://apis.net.pe/api-ruc',
    'Authorization: Bearer ' . $token
  ),
));

$response = curl_exec($curl);

curl_close($curl);

// Datos de empresas según padron reducido
$empresa = json_decode($response);

if ($empresa === null) {
    // Si hay un error en la respuesta de la API, devuelve un mensaje de error
    http_response_code(500);
    echo json_encode(array("message" => "Error en la llamada a la API."));
    exit;
}

// Devuelve la respuesta de la API como JSON
header('Content-Type: application/json');
echo json_encode($empresa);

?>
