<?php
error_reporting(E_ALL ^ E_NOTICE);
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST, PUT, GET, DELETE, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");
header("Content-Type: application/json");

// Si la solicitud es de tipo OPTIONS, responde con los encabezados CORS y termina la ejecucin
if ($_SERVER['REQUEST_METHOD'] === 'OPTIONS') {
    header("HTTP/1.1 200 OK");
    exit;
}

// Directorio donde se encuentran los archivos
$directorioArchivos = dirname(__FILE__) . '/pdf/'; // Ruta relativa al directorio actual del archivo PHP

if (!empty($_GET['nombre'])) {
    // Obtener el nombre del archivo codificado en base64 desde la URL
    $base64FileName = $_GET['nombre'];
    
    // Decodificar el nombre del archivo desde base64
    $fileName = base64_decode($base64FileName);

    // Construir la ruta del archivo
    $rutaArchivo = $directorioArchivos . $fileName;

    // Validar que el archivo exista
    if (file_exists($rutaArchivo)) {
        // Establecer las cabeceras para la descarga
        header('Content-Description: File Transfer');
        header('Content-Type: application/octet-stream');
        header('Content-Disposition: attachment; filename="' . $fileName . '"');
        header('Content-Length: ' . filesize($rutaArchivo));

        // Enviar el archivo al cliente
        readfile($rutaArchivo);
        exit;
    }
}

// El archivo no existe
http_response_code(404);
echo 'El archivo solicitado no esta disponible para descarga.';
exit;
?>
