<?php
error_reporting(E_ALL ^ E_NOTICE);
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST, PUT, GET, DELETE, OPTIONS"); // Agregar DELETE si es necesario
header("Access-Control-Allow-Headers: Content-Type");
header("Content-Type: application/json");

// Incluir archivo de conexión
include_once '../conexion.php';

// Obtener cuerpo de la solicitud
$bodyRequest = file_get_contents("php://input");
$datos = json_decode($bodyRequest, true);

// Verificar si todos los campos requeridos están presentes
$camposRequeridos = ['tipo_proceso'];
foreach ($camposRequeridos as $campo) {
    if (!isset($datos[$campo])) {
        $resultado['ESTADO'] = "0";
        $resultado['MENSAJE'] = "Falta el campo obligatorio: $campo";
        print_json($resultado);
        exit;
    }
}

// Sentencia SQL preparada para actualizar los datos
$sql = "UPDATE Empresa SET tipo_proceso=? WHERE ID_Empresa ='1'";

$stmt = mysqli_prepare($conn, $sql);

if ($stmt) {
    // Enlazar parámetros y ejecutar la sentencia
    mysqli_stmt_bind_param($stmt, "s", $datos['tipo_proceso']);

    $result = mysqli_stmt_execute($stmt);

    if ($result) {
        $resultado['ESTADO'] = "1";
        $resultado['MENSAJE'] = "Tipo de proceso actualizada correctamente";
    } else {
        $resultado['ESTADO'] = "0";
        $resultado['MENSAJE'] = "ERROR AL ACTUALIZAR LA INFORMACION: " . mysqli_error($conn);
    }

    mysqli_stmt_close($stmt);
} else {
    $resultado['ESTADO'] = "0";
    $resultado['MENSAJE'] = "ERROR EN LA PREPARACION DE LA SENTENCIA: " . mysqli_error($conn);
}

print_json($resultado);

// Cierre de la conexión a la base de datos
mysqli_close($conn);

function print_json($data)
{
    header("HTTP/1.1");
    header("Content-Type: application/json; charset=UTF-8");
    echo json_encode($data, JSON_PRETTY_PRINT);
}
?>
