<?php
error_reporting(E_ALL ^ E_NOTICE);
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST, PUT, GET, DELETE, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");
header("Content-Type: application/json");

include_once '../conexion.php';

date_default_timezone_set("America/Lima");
$bodyRequest = file_get_contents("php://input");


$datos = json_decode($bodyRequest, true);
$fecha_actual_peru = date('Y-m-d');

// Validar el método de solicitud
$method = $_SERVER['REQUEST_METHOD'];
if ($method !== 'GET') {
    http_response_code(405); // Método no permitido
    echo json_encode(array("message" => "Method not allowed"));
    exit;
}



$sql = "SELECT * FROM Empresa";
$rows = array();

if ($stmt = mysqli_prepare($conn, $sql)) {
    if (mysqli_stmt_execute($stmt)) {
        $result = mysqli_stmt_get_result($stmt);
        if (mysqli_num_rows($result) > 0) {
            while ($row = mysqli_fetch_assoc($result)) {
                $rows[] = $row;
            }
            mysqli_free_result($result);
        } else {
            http_response_code(404); // No se encontraron registros
            echo json_encode(array("message" => "No records found"));
        }
    } else {
        http_response_code(500); // Error del servidor
        echo json_encode(array("message" => "Could not execute query"));
    }
    mysqli_stmt_close($stmt);
} else {
    http_response_code(500); // Error del servidor
    echo json_encode(array("message" => "Could not prepare statement"));
}

print_json($rows);
mysqli_close($conn);

function print_json($data) {
    header("Content-type: application/json; charset=utf-8");
    echo json_encode($data, JSON_UNESCAPED_UNICODE);
    	
    switch (json_last_error()) {
        case JSON_ERROR_NONE:
            //  echo ' - No errors';
            break;
        case JSON_ERROR_DEPTH:
            echo ' - Maximum stack depth exceeded';
            break;
        case JSON_ERROR_STATE_MISMATCH:
            echo ' - Underflow or the modes mismatch';
            break;
        case JSON_ERROR_CTRL_CHAR:
            echo ' - Unexpected control character found';
            break;
        case JSON_ERROR_SYNTAX:
            echo ' - Syntax error, malformed JSON';
            break;
        case JSON_ERROR_UTF8:
            echo ' - Malformed UTF-8 characters, possibly incorrectly encoded';
            break;
        default:
            echo ' - Unknown error';
            break;
	}
}
?>
