<?php
error_reporting(E_ALL ^ E_NOTICE);
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST, PUT, GET, DELETE, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");
header("Content-Type: application/json");

include_once '../conexion.php';

try {
    $bodyRequest = file_get_contents("php://input");
    
    // Iniciar transaccion
    mysqli_begin_transaction($conn);
    
    $nombre_tabla = 'Insumos';
    $tipo_permiso = 'editar';
    
    if ($bodyRequest === false) {
        throw new Exception("Error al leer los datos de la solicitud.", 400);
    }

    // Verificar si se enviaron datos en la solicitud
    if (empty($bodyRequest)) {
        throw new Exception("No se han enviado datos en la solicitud.", 400);
    }

    // Decodificar los datos JSON
    $datos = json_decode($bodyRequest, true);
    if ($datos === null) {
        throw new Exception("Error al decodificar los datos JSON.", 400);
    }

    // Verificar si se proporciono el campo Nombre_Sucursal y token
    if (!isset($datos['token'], $datos['Cantidad'], $datos['Nombre_Insumo'])) {
         throw new Exception("Faltan datos requeridos.", 400);
    }

    // Verificar si el campo Nombre_Sucursal y token no esten vacio y no consiste solo en espacios en blanco
   // if (empty($datos['Stock']) ||empty($datos['Precio_Unitario2']) ||empty($datos['Precio_Unitario3']) ||empty($datos['Nombre_Producto']) || empty($datos['token']) || trim($datos['Precio_Unitario']) === '' || trim($datos['token']) === '') {
   //     throw new Exception("Campos vacíos o con espacios en blanco, llene datos para editar.", 400);
   // }
   
if ((empty($datos['Cantidad']) && $datos['Cantidad'] !== '0' && $datos['Cantidad'] !== 0) || empty($datos['Nombre_Insumo']) || empty($datos['token']) || trim($datos['Precio_Unitario']) === '' || trim($datos['token']) === '') {
    $campos_vacios = [];
    if ((empty($datos['Cantidad']) && $datos['Cantidad'] !== '0')) {
        $campos_vacios[] = 'Cantidad';
    }
    if (empty($datos['Nombre_Insumo'])) {
        $campos_vacios[] = 'Nombre_Insumo';
    }
    if (empty($datos['token'])) {
        $campos_vacios[] = 'token';
    }
    if (trim($datos['Precio_Unitario']) === '') {
        $campos_vacios[] = 'Precio_Unitario';
    }
    if (trim($datos['token']) === '') {
        $campos_vacios[] = 'token';
    }
    
    $mensaje = "Los siguientes campos están vacíos: " . implode(', ', $campos_vacios) . ". Llene datos para editar.";
    
    throw new Exception($mensaje, 400);
}



    // Obtener otros datos del array
    $token = $datos['token'];
    $ID_Insumo = $datos['ID_Insumo'];
    
    $Foto = "https://lesaffre.com.pe/wp-content/uploads/2020/09/Timeline_6B_OtrosInsumos.jpg";

    $Nombre_Insumo = isset($datos['Nombre_Insumo']) ? mysqli_real_escape_string($conn, $datos['Nombre_Insumo']) : '';
    $Unidad_Principal = isset($datos['Unidad_Principal']) ? mysqli_real_escape_string($conn, $datos['Unidad_Principal']) : '';
    $Precio_Unitario = isset($datos['Precio_Unitario']) ? mysqli_real_escape_string($conn, $datos['Precio_Unitario']) : '';
    $ID_Stock = isset($datos['ID_Stock']) ? mysqli_real_escape_string($conn, $datos['ID_Stock']) : '';
    $ID_Sucursal = isset($datos['ID_Sucursal']) ? mysqli_real_escape_string($conn, $datos['ID_Sucursal']) : '';
    $ID_Insumo_Stock = isset($datos['ID_Insumo_Stock']) ? mysqli_real_escape_string($conn, $datos['ID_Insumo_Stock']) : '';
    
    $Cantidad = isset($datos['Cantidad']) ? mysqli_real_escape_string($conn, $datos['Cantidad']) : '';
    $ID_Insumo_Unidad = isset($datos['ID_Insumo_Unidad']) ? mysqli_real_escape_string($conn, $datos['ID_Insumo_Unidad']) : ''; 
    $ID_Unidad = isset($datos['ID_Unidad']) ? mysqli_real_escape_string($conn, $datos['ID_Unidad']) : ''; 
    $Factor_Conversion = isset($datos['Factor_Conversion']) ? mysqli_real_escape_string($conn, $datos['Factor_Conversion']) : '';
    $Nombre_Unidad= isset($datos['Nombre_Unidad']) ? mysqli_real_escape_string($conn, $datos['Nombre_Unidad']) : '';
    
    
    
    // Verificar autorizacion del usuario y permisos
    $id_usuario = obtenerIdUsuarioPorToken($conn, $token);
    if ($id_usuario === null) {
        throw new Exception("Token de autorizacion invalido.", 401);
    }
    
    $permiso = tienePermiso($conn, $id_usuario, $nombre_tabla, $tipo_permiso);
    if ($permiso === null) {
        throw new Exception("El usuario no tiene permisos para editar esta tabla.", 403);
    } elseif (!$permiso) {
        throw new Exception("El usuario no tiene permisos para editar en esta tabla.", 403);
    }
    
    // Preparar y ejecutar la consulta preparada SQL
    $sql_update_Productos = "UPDATE Insumos SET Nombre_Insumo=?, Unidad_Principal=?, Precio_Unitario=?, Foto=? WHERE ID_Insumo = ?";
    $stmt = mysqli_prepare($conn, $sql_update_Productos);
    mysqli_stmt_bind_param($stmt, "ssssi", $Nombre_Insumo, $Unidad_Principal, $Precio_Unitario, $Foto, $ID_Insumo);
    if (!mysqli_stmt_execute($stmt)) {
        throw new Exception("Error al actualizar Nombre_Insumo: " . mysqli_stmt_error($stmt), 500);
    }
    
  
    $sql_update_Productos_Unidades = "UPDATE Insumos_Unidades SET ID_Insumo=?, ID_Unidad=?, Factor_Conversion=? WHERE ID_Insumo_Unidad = ?";
    $stmt = mysqli_prepare($conn, $sql_update_Productos_Unidades);
    mysqli_stmt_bind_param($stmt, "sssi", $ID_Insumo, $ID_Unidad, $Factor_Conversion,  $ID_Insumo_Unidad);
    if (!mysqli_stmt_execute($stmt)) {
        throw new Exception("Error al actualizar Insumos_Unidades: " . mysqli_stmt_error($stmt), 500);
    }
    
    $sql_update_StockProductos_PorSucursal = "UPDATE Stock_Insumos_Sucursal SET Cantidad=? WHERE ID_Stock  = ?";
    $stmt = mysqli_prepare($conn, $sql_update_StockProductos_PorSucursal);
    mysqli_stmt_bind_param($stmt, "si", $Cantidad, $ID_Stock);
    if (!mysqli_stmt_execute($stmt)) {
        throw new Exception("Error al actualizar Stock_Insumos_Sucursal: " . mysqli_stmt_error($stmt), 500);
    }
    
    
    // Cerrar la consulta preparada
    mysqli_stmt_close($stmt);


    // Confirmar la transaccion
    mysqli_commit($conn);

    $resultado['ESTADO'] = "1";
    $resultado['MENSAJE'] = "La informacion se actualizo correctamente";
    $resultado['CODIGO'] = "200";
 
} catch (Exception $e) {
    // En caso de error, hacer rollback de la transaccion
    mysqli_rollback($conn);
    
    $resultado['ESTADO'] = "0";
    $resultado['MENSAJE'] = $e->getMessage();
    $resultado['CODIGO'] = $e->getCode();
}

// Imprimir respuesta en formato JSON
print_json($resultado);
mysqli_close($conn);

// Funcion para imprimir respuesta en formato JSON
function print_json($data) {
    header("HTTP/1.1");
    header("Content-Type: application/json; charset=UTF-8");
    echo json_encode($data, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE);
}

// Funcion para obtener el ID de usuario por token
function obtenerIdUsuarioPorToken($conn, $token) {
    $sql = "SELECT id_usuario FROM sesiones WHERE token = ?";
    $stmt = mysqli_prepare($conn, $sql);
    mysqli_stmt_bind_param($stmt, "s", $token);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $idUsuario);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);
    return $idUsuario;
}

// Funcion para verificar si el usuario tiene permisos
function tienePermiso($conn, $idUsuario, $tabla, $tipo_permiso_usuario) {
    $sql = "SELECT $tipo_permiso_usuario FROM permisos WHERE id_usuario = ? AND tabla = ?";
    $stmt = mysqli_prepare($conn, $sql);
    mysqli_stmt_bind_param($stmt, "is", $idUsuario, $tabla);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $tienePermiso);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);
    return $tienePermiso;
}
?>
