<?php

// Incluye la librería FPDF y la librería PHP QR Code
require 'fpdf/fpdf.php';
require 'vendor/autoload.php';
header('Content-Type: text/html; charset=utf-8');

// Define la moneda
define('MONEDA', 's/');


function generarPDF($data)
{
    $anchoA4 = 210;
    $altoA4 = 297;
    // Extracción de datos del JSON recibido
    $tipo_documento = isset($data['tipo_documento']) ? $data['tipo_documento'] : '';
    $empresa = 'EMPRESA RAZER STORE EMPRESA INDIVIDUAL DE RESPONSABILIDAD LIMITADA';
    $ruc = '20615649879';
    $direccion = (utf8_decode('CAL.OCTAVIO MUÑOZ NAJAR NRO. 223 INT. 302 URB. CERCADO (CENTRO COMERCIAL COMPUPLAZA) AREQUIPA - AREQUIPA - AREQUIPA'));
    $telefono = '134679';
    $nrocomprobante = 'F001-13456789';
    $correo = isset($data['correo']) ? $data['correo'] : '';
    $fecha_venta = isset($data['Fecha_Venta']) ? $data['Fecha_Venta'] : '';
    $hora = isset($data['HoraVenta']) ? $data['HoraVenta'] : '';
    $detalle = isset($data['Detalle']) ? $data['Detalle'] : '';

    // Generar el PDF
    $pdf = new FPDF('P', 'mm', 'A4');
    $pdf->AddPage();
    $pdf->SetMargins(5, 5, 5);
    $pdf->SetFont('Arial', 'B', 9);

    // LOGO COLUMNA 1 FILA 1
    //$pdf->Image('../logo.jpg', 5, 10, 45);
    // Obtener las dimensiones de la imagen
    list($ancho_original, $alto_original) = getimagesize('../logo.jpg');

    // Definir las dimensiones máximas permitidas
    $ancho_maximoo = 50;
    $alto_maximoo = 30;

    // Calcular la escala para ajustar las dimensiones de la imagen
    $escala_ancho = $ancho_maximoo / $ancho_original;
    $escala_alto = $alto_maximoo / $alto_original;

    // Utilizar la escala más pequeña para asegurar que la imagen se ajuste dentro de los límites máximos
    $escala = min($escala_ancho, $escala_alto);

    // Calcular las nuevas dimensiones de la imagen
    $nuevo_ancho = $ancho_original * $escala;
    $nuevo_alto = $alto_original * $escala;

    // Insertar la imagen en el PDF con las nuevas dimensiones
    $pdf->Image('../logo.jpg', 5, 5, $nuevo_ancho, $nuevo_alto);




    // Insertar la imagen en el PDF con las nuevas dimensiones
    $pdf->Image('doc.png', 158, 5, 44, 25);




    // Información de la empresa  COLUMNA 2 FILA 1
    $pdf->SetFont('Arial', '', 7);
    $lineasEmpresa = dividirTexto(utf8_decode($empresa), 70);
    foreach ($lineasEmpresa as $linea) {
        $pdf->Cell(0, 5, $linea, 0, 1, 'C');
    }

    $pdf->SetFont('Arial', '', 7);
    $lineasDireccion = dividirTexto(utf8_decode($direccion), 70);
    foreach ($lineasDireccion as $linea) {
        $pdf->Cell(0, 5, $linea, 0, 1, 'C');
    }

    $pdf->Cell(0, 5, utf8_decode('Teléfono: ' . $telefono), 0, 1, 'C');
    $pdf->Cell(0, 5, utf8_decode('Correo: ' . $correo), 0, 1, 'C');



    $x = $anchoA4 - 45; // 85 es el ancho de la imagen más un pequeño espacio para separación
    $y = 8;


    // Establecer la fuente para la imagen (en este caso, Arial no requiere una fuente adicional)
    $fuenteImagen = 3; // 1 para Arial, 2 para otras fuentes
    // Crear una imagen con GD
    $imagen = imagecreate(280, 80); // Ancho y alto de la imagen
    $colorFondo = imagecolorallocate($imagen, 255, 255, 255); // Color de fondo blanco
    $colorTexto = imagecolorallocate($imagen, 0, 0, 0); // Color de texto negro
    // Definir los textos a mostrar en la imagen
    $texto1 = 'RUC: ' . $ruc;
    $texto2 = $tipo_documento;
    $texto3 = $nrocomprobante;
    // Escribir los textos en la imagen utilizando la fuente Arial
    imagestring($imagen, $fuenteImagen, 10, 10, utf8_decode($texto1), $colorTexto);
    imagestring($imagen, $fuenteImagen, 0, 30, utf8_decode($texto2), $colorTexto);
    imagestring($imagen, $fuenteImagen, 19, 50, utf8_decode($texto3), $colorTexto);
    // Guardar la imagen como archivo PNG
    imagepng($imagen, 'datos.png');
    // Liberar memori
    imagedestroy($imagen);
    // Incluir la imagen en el PDF generado
    $pdf->Image('datos.png', $x, $y, 70, 20); // Ajusta el tamaño según sea necesario

    $pdf->Ln(3);
    $pdf->SetDrawColor(42, 120, 176);
    $pdf->Line(5, $pdf->GetY(), 200, $pdf->GetY());
    $pdf->SetDrawColor(0);

    $pdf->SetFont('Arial', 'B', 8);
    $pdf->Cell(20, 4, 'Fecha emision.', 0, 0, 'L');
    $pdf->Cell(9, 4, ':', 0, 0, 'R');
    $pdf->SetFont('Arial', '', 8);
    $pdf->Cell(60, 4, '20654-78-485', 0, 1, 'L');

    $pdf->SetFont('Arial', 'B', 8);
    $pdf->Cell(20, 4, 'Fecha vencimiento', 0, 0, 'L');
    $pdf->Cell(9, 4, ':', 0, 0, 'R');
    $pdf->SetFont('Arial', '', 8);
    $pdf->Cell(60, 4, '20654-78-485', 0, 1, 'L');

    $pdf->SetFont('Arial', 'B', 8);
    $pdf->Cell(20, 4, 'Hora emision', 0, 0, 'L');
    $pdf->Cell(9, 4, ':', 0, 0, 'R');
    $pdf->SetFont('Arial', '', 8);
    $pdf->Cell(60, 4, '00:00:00', 0, 1, 'L');

    $pdf->SetFont('Arial', 'B', 8);
    $pdf->Cell(20, 4, 'RUC/DNI ', 0, 0, 'L');
    $pdf->Cell(9, 4, ':', 0, 0, 'R');
    $pdf->SetFont('Arial', '', 8);
    $pdf->Cell(60, 4, '132456789789', 0, 1, 'L');

    $pdf->SetFont('Arial', 'B', 8);
    $pdf->Cell(20, 4, 'Razon Social ', 0, 0, 'L');
    $pdf->Cell(9, 4, ':', 0, 0, 'R');
    $pdf->SetFont('Arial', '', 8);
    $pdf->Cell(60, 4, 'emrpesa asd', 0, 1, 'L');

    $pdf->SetFont('Arial', 'B', 8);
    $pdf->Cell(20, 4, 'Direccion ', 0, 0, 'L');
    $pdf->Cell(9, 4, ':', 0, 0, 'R');
    $pdf->SetFont('Arial', '', 8);
    $textoDireccion = "CAL.OCTAVIO MUÑOZ NAJAR NRO. 223 INT. 302 URB. CERCADO (CENTRO COMERCIAL COMPUPLAZA) AREQUIPA - AREQUIPA - AREQUIPA";

    // Convertir la primera letra de cada palabra en mayúscula
    $textoDireccion = ucwords(strtolower($textoDireccion));
    $lineasDireccion = dividirTexto(utf8_decode($textoDireccion), 180);
    foreach ($lineasDireccion as $linea) {
        $pdf->Cell(0, 5, $linea, 0, 1, 'L');
    }



    $pdf->Ln(2);
    // Línea divisoria
    $pdf->SetDrawColor(42, 120, 176);
    $pdf->Line(5, $pdf->GetY(), 200, $pdf->GetY());
    $pdf->SetDrawColor(0);

    // Encabezados de la tabla de detalle
    $pdf->SetFont('Arial', 'B', 8);
    $pdf->Cell(10, 4, 'Cant.', 0, 0, 'L');
    $pdf->Cell(150, 4, utf8_decode('Descripción'), 0, 0, 'L');
    $pdf->Cell(20, 4, 'Precio', 0, 0, 'C');
    $pdf->Cell(20, 4, 'Importe', 0, 1, 'C');
    $pdf->SetDrawColor(42, 120, 176);
    $pdf->Line(5, $pdf->GetY(), 200, $pdf->GetY());
    $pdf->SetDrawColor(0);
    $pdf->Ln(2); // Salto de línea después de la línea divisoria
    $pdf->SetFont('Arial', '', 8);




    // Total de productos
    $totalProductos = 0;
    $pdf->SetFont('Arial', '', 7);

    // Detalle de la venta
    foreach ($detalle as $item) {
        $pdf->Cell(10, 4, $item['Cantidad_Vendida'], 0, 0, 'L');

        $yInicio = $pdf->GetY();
        $pdf->MultiCell(110, 4, utf8_decode($item['producto']), 0, 'L');
        $yFin = $pdf->GetY();

        $pdf->SetXY(45, $yInicio);

        // Ancho de Precio_Unitario
        $precioWidth = 250;

        // Precio_Unitario
        $pdf->Cell($precioWidth, 4, MONEDA . ' ' . number_format($item['Precio_Unitario'], 2, '.', ','), 0, 0, 'C');

        // Calcular la posición X del Importe
        $xImporte = 150; // 5 puntos de separación

        $pdf->SetXY($xImporte, $yInicio);
        $pdf->Cell(50, 4, MONEDA . ' ' . $item['Importe'], 0, 1, 'R');
        $pdf->SetY($yFin);

        $totalProductos += $item['Cantidad_Vendida'];
    }

    $pdf->Ln(3);
    // Total de artículos
    $pdf->Cell(70, 4, utf8_decode('Número de artículos:  ') . $totalProductos, 0, 1, 'L');
    $pdf->Cell(70, 4, utf8_decode('SON 100 SOLES /100 SOLES'));
    $pdf->Ln();

    // Total de la venta
    $pdf->SetFont('Arial', 'B', 8);
    $pdf->Cell(170, 5, 'Sub-Total:', 0, 0, 'R');
    $pdf->Cell(25, 5, MONEDA . ' ' . number_format($data['Total_Grabadas'], 2, '.', ','), 0, 1, 'R');

    $pdf->SetFont('Arial', 'B', 8);
    $pdf->Cell(170, 5, 'IGV:', 0, 0, 'R');
    $pdf->Cell(25, 5, MONEDA . ' ' . number_format($data['Total_IGV'], 2, '.', ','), 0, 1, 'R');

    $pdf->SetFont('Arial', 'B', 8);
    $pdf->Cell(170, 5, 'Total:', 0, 0, 'R');
    $pdf->Cell(25, 5, MONEDA . ' ' . number_format($data['Total'], 2, '.', ','), 0, 1, 'R');

    // Generar QR desde el texto proporcionado por el cliente
    $qrText = ($data['token']); // Aquí debes reemplazar con el texto real proporcionado por el cliente
    $qrCode = new chillerlan\QRCode\QRCode(new chillerlan\QRCode\QROptions([
        'outputType' => 'png',
        'eccLevel' => 0, // Reemplaza QR_ECLEVEL_L por el valor numérico correspondiente
        'imageBase64' => false,
    ]));

    $qrImagePath = 'qr.png'; // Ruta donde se guardará el archivo QR
    $qrCode->render($qrText, $qrImagePath);

    // Incrustar el QR en el PDF
    $pdf->Image($qrImagePath, 172, $pdf->GetY() + 1, 30, 30); // Ajusta la posición y el tamaño según sea necesario

    // Salida del PDF
    $output = $pdf->Output('S');

    // Ruta de la carpeta para guardar el PDF
    $pdfFolder = '../pdf/';

    // Nombre del archivo PDF
    $pdfName = uniqid() . 'hola.pdf';

    // Ruta completa del PDF
    $pdfPath = $pdfFolder . $pdfName;

    // Guardar el PDF en la carpeta
    file_put_contents($pdfPath, $output);

    // Devolver la ruta del archivo guardado
    return $pdfPath;
}

// Función para dividir el texto en líneas de máximo $maxLength caracteres
function dividirTexto($texto, $maxLength)
{
    $lineas = [];
    $palabras = explode(" ", $texto);
    $lineaActual = '';

    foreach ($palabras as $palabra) {
        $lineaPropuesta = $lineaActual . ' ' . $palabra;
        if (strlen($lineaPropuesta) <= $maxLength) {
            $lineaActual = $lineaPropuesta;
        } else {
            $lineas[] = trim($lineaActual);
            $lineaActual = $palabra;
        }
    }

    $lineas[] = trim($lineaActual);

    return $lineas;
}

// Recibir datos del cliente en formato JSON
$data = json_decode(file_get_contents('php://input'), true);

// Verificar si se recibieron datos válidos desde el cliente
if (!empty($data)) {
    // Generar el PDF y obtener la ruta del archivo guardado
    $pdfPath = generarPDF($data);

    // Devolver la ruta del archivo PDF guardado como respuesta de la API
    echo json_encode(array('pdf_path' => $pdfPath));
} else {
    // Si no se reciben datos válidos, devolver un mensaje de error
    echo json_encode(array('error' => 'No se recibieron datos válidos'));
}

?>