<?php
error_reporting(E_ALL ^ E_NOTICE);
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST, PUT, GET, DELETE, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");
header("Content-Type: application/json");

include_once '../conexion.php';

try {
    $bodyRequest = file_get_contents("php://input");
    
    // Iniciar transaccion
    //mysqli_begin_transaction($conn);
    
    $nombre_tabla = 'Productos';
    $tipo_permiso = 'editar';
    
    if ($bodyRequest === false) {
        throw new Exception("Error al leer los datos de la solicitud.", 400);
    }

    // Verificar si se enviaron datos en la solicitud
    if (empty($bodyRequest)) {
        throw new Exception("No se han enviado datos en la solicitud.", 400);
    }

    // Decodificar los datos JSON
    $datos = json_decode($bodyRequest, true);
    if ($datos === null) {
        throw new Exception("Error al decodificar los datos JSON.", 400);
    }

    // Verificar si se proporciono el campo Nombre_Sucursal y token
    if (!isset($datos['token'], $datos['ID_Producto'], $datos['Nombre_Producto'])) {
         throw new Exception("Faltan datos requeridos.", 400);
    }

    // Verificar si el campo Nombre_Sucursal y token no esten vacio y no consiste solo en espacios en blanco
   // if (empty($datos['Stock']) ||empty($datos['Precio_Unitario2']) ||empty($datos['Precio_Unitario3']) ||empty($datos['Nombre_Producto']) || empty($datos['token']) || trim($datos['Precio_Unitario']) === '' || trim($datos['token']) === '') {
   //     throw new Exception("Campos vacíos o con espacios en blanco, llene datos para editar.", 400);
   // }
   
if ((empty($datos['Stock']) && $datos['Stock'] !== '0' && $datos['Stock'] !== 0) || empty($datos['Precio_Unitario2']) || empty($datos['Precio_Unitario3']) || empty($datos['Nombre_Producto']) || empty($datos['token']) || trim($datos['Precio_Unitario']) === '' || trim($datos['token']) === '') {
    $campos_vacios = [];
    if ((empty($datos['Stock']) && $datos['Stock'] !== '0')) {
        $campos_vacios[] = 'Stock';
    }
    if (empty($datos['Precio_Unitario2'])) {
        $campos_vacios[] = 'Precio_Unitario2';
    }
    if (empty($datos['Precio_Unitario3'])) {
        $campos_vacios[] = 'Precio_Unitario3';
    }
    if (empty($datos['Nombre_Producto'])) {
        $campos_vacios[] = 'Nombre_Producto';
    }
    if (empty($datos['token'])) {
        $campos_vacios[] = 'token';
    }
    if (trim($datos['Precio_Unitario']) === '') {
        $campos_vacios[] = 'Precio_Unitario';
    }
    if (trim($datos['token']) === '') {
        $campos_vacios[] = 'token';
    }
    
    $mensaje = "Los siguientes campos están vacíos: " . implode(', ', $campos_vacios) . ". Llene datos para editar.";
    
    throw new Exception($mensaje, 400);
}



    // Obtener otros datos del array
    $token = $datos['token'];
    $ID_Producto = $datos['ID_Producto'];
    
    $Foto1 = "https://jumpseller.mx/generated/images/learn/los-10-productos-mas-vendidos-en-mexico/online-shopping-mexico-800-3423d44e0.png";
    $Foto2 = "https://jumpseller.mx/generated/images/learn/los-10-productos-mas-vendidos-en-mexico/online-shopping-mexico-800-3423d44e0.png";
    $Foto3 = "https://jumpseller.mx/generated/images/learn/los-10-productos-mas-vendidos-en-mexico/online-shopping-mexico-800-3423d44e0.png";
    
    $Nombre_Producto = isset($datos['Nombre_Producto']) ? mysqli_real_escape_string($conn, $datos['Nombre_Producto']) : '';
    $Estado_Activo = isset($datos['Estado_Activo']) ? mysqli_real_escape_string($conn, $datos['Estado_Activo']) : '';
    $ID_Sucursal = isset($datos['ID_Sucursal']) ? mysqli_real_escape_string($conn, $datos['ID_Sucursal']) : '';
    $ID_Categoria = isset($datos['ID_Categoria']) ? mysqli_real_escape_string($conn, $datos['ID_Categoria']) : '';
    $Categoria = isset($datos['Categoria']) ? mysqli_real_escape_string($conn, $datos['Categoria']) : '';
    $ID_StockProducto = isset($datos['ID_StockProducto']) ? mysqli_real_escape_string($conn, $datos['ID_StockProducto']) : '';
    $Stock = isset($datos['Stock']) ? mysqli_real_escape_string($conn, $datos['Stock']) : '';
    
    $ID_Precio_Producto_Sucursal = isset($datos['ID_Precio_Producto_Sucursal']) ? mysqli_real_escape_string($conn, $datos['ID_Precio_Producto_Sucursal']) : ''; 
    $Precio_Unitario = isset($datos['Precio_Unitario']) ? mysqli_real_escape_string($conn, $datos['Precio_Unitario']) : ''; 
    $Precio_Unitario2 = isset($datos['Precio_Unitario2']) ? mysqli_real_escape_string($conn, $datos['Precio_Unitario2']) : '';
    $Precio_Unitario3 = isset($datos['Precio_Unitario3']) ? mysqli_real_escape_string($conn, $datos['Precio_Unitario3']) : '';
    $ID_Producto_Unidad = isset($datos['ID_Producto_Unidad']) ? mysqli_real_escape_string($conn, $datos['ID_Producto_Unidad']) : '';
    $ID_Unidad = isset($datos['ID_Unidad']) ? mysqli_real_escape_string($conn, $datos['ID_Unidad']) : '';
    $Nombre_Unidad = isset($datos['Nombre_Unidad']) ? mysqli_real_escape_string($conn, $datos['Nombre_Unidad']) : '';
    $Factor_Conversion = isset($datos['Factor_Conversion']) ? mysqli_real_escape_string($conn, $datos['Factor_Conversion']) : '';
    $ID_Foto = isset($datos['ID_Foto']) ? mysqli_real_escape_string($conn, $datos['ID_Foto']) : '';
    
    
    // Verificar autorizacion del usuario y permisos
    $id_usuario = obtenerIdUsuarioPorToken($conn, $token);
    if ($id_usuario === null) {
        throw new Exception("Token de autorizacion invalido.", 401);
    }
    
    $permiso = tienePermiso($conn, $id_usuario, $nombre_tabla, $tipo_permiso);
    if ($permiso === null) {
        throw new Exception("El usuario no tiene permisos para editar esta tabla.", 403);
    } elseif (!$permiso) {
        throw new Exception("El usuario no tiene permisos para editar en esta tabla.", 403);
    }
    
    // Preparar y ejecutar la consulta preparada SQL
    $sql_update_Productos = "UPDATE Productos SET Estado_Activo=?, Nombre_Producto=?, ID_Sucursal=?, ID_Categoria=? WHERE ID_Producto = ?";
    $stmt = mysqli_prepare($conn, $sql_update_Productos);
    mysqli_stmt_bind_param($stmt, "ssssi", $Estado_Activo, $Nombre_Producto, $ID_Sucursal, $ID_Categoria, $ID_Producto);
    if (!mysqli_stmt_execute($stmt)) {
        throw new Exception("Error al actualizar Producto: " . mysqli_stmt_error($stmt), 500);
    }
    
    $sql_update_Productos_Unidades = "UPDATE Productos_Unidades SET ID_Producto=?, ID_Unidad=?, Factor_Conversion=? WHERE ID_Producto_Unidad = ?";
    $stmt = mysqli_prepare($conn, $sql_update_Productos_Unidades);
    mysqli_stmt_bind_param($stmt, "sssi", $ID_Producto, $ID_Unidad, $Factor_Conversion,  $ID_Producto_Unidad);
    if (!mysqli_stmt_execute($stmt)) {
        throw new Exception("Error al actualizar Productos_Unidades: " . mysqli_stmt_error($stmt), 500);
    }
    
    $sql_update_StockProductos_PorSucursal = "UPDATE StockProductos_PorSucursal SET Stock=? WHERE ID_StockProducto = ?";
    $stmt = mysqli_prepare($conn, $sql_update_StockProductos_PorSucursal);
    mysqli_stmt_bind_param($stmt, "si", $Stock, $ID_StockProducto);
    if (!mysqli_stmt_execute($stmt)) {
        throw new Exception("Error al actualizar StockProductos_PorSucursal: " . mysqli_stmt_error($stmt), 500);
    }
    
    $sql_update_Producto_Foto = "UPDATE Producto_Foto SET ID_Producto=?, Foto1=?, Foto2=?, Foto3=? WHERE ID_Foto = ?";
    $stmt = mysqli_prepare($conn, $sql_update_Producto_Foto);
    mysqli_stmt_bind_param($stmt, "ssssi", $ID_Producto,$Foto1,$Foto2,$Foto3, $ID_Foto);
    if (!mysqli_stmt_execute($stmt)) {
        throw new Exception("Error al actualizar Producto_Foto: " . mysqli_stmt_error($stmt), 500);
    }
    
    $sql_update_Precios_Productos_Sucursal = "UPDATE Precios_Productos_Sucursal SET ID_Producto=?, ID_Sucursal=?, Precio_Unitario=?, Precio_Unitario2=?, Precio_Unitario3=? WHERE ID_Precio_Producto_Sucursal = ?";
    $stmt = mysqli_prepare($conn, $sql_update_Precios_Productos_Sucursal);
    mysqli_stmt_bind_param($stmt, "sssssi", $ID_Producto,$ID_Sucursal,$Precio_Unitario,$Precio_Unitario2, $Precio_Unitario3,$ID_Precio_Producto_Sucursal);
    if (!mysqli_stmt_execute($stmt)) {
        throw new Exception("Error al actualizar Precios_Productos_Sucursal: " . mysqli_stmt_error($stmt), 500);
    }
    
    // Cerrar la consulta preparada
    mysqli_stmt_close($stmt);


    // Confirmar la transaccion
    //mysqli_commit($conn);

    $resultado['ESTADO'] = "1";
    $resultado['MENSAJE'] = "La informacion se actualizo correctamente";
    $resultado['CODIGO'] = "200";
 
} catch (Exception $e) {
    // En caso de error, hacer rollback de la transaccion
   // mysqli_rollback($conn);
    
    $resultado['ESTADO'] = "0";
    $resultado['MENSAJE'] = $e->getMessage();
    $resultado['CODIGO'] = $e->getCode();
}

// Imprimir respuesta en formato JSON
print_json($resultado);
mysqli_close($conn);

// Funcion para imprimir respuesta en formato JSON
function print_json($data) {
    header("HTTP/1.1");
    header("Content-Type: application/json; charset=UTF-8");
    echo json_encode($data, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE);
}

// Funcion para obtener el ID de usuario por token
function obtenerIdUsuarioPorToken($conn, $token) {
    $sql = "SELECT id_usuario FROM sesiones WHERE token = ?";
    $stmt = mysqli_prepare($conn, $sql);
    mysqli_stmt_bind_param($stmt, "s", $token);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $idUsuario);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);
    return $idUsuario;
}

// Funcion para verificar si el usuario tiene permisos
function tienePermiso($conn, $idUsuario, $tabla, $tipo_permiso_usuario) {
    $sql = "SELECT $tipo_permiso_usuario FROM permisos WHERE id_usuario = ? AND tabla = ?";
    $stmt = mysqli_prepare($conn, $sql);
    mysqli_stmt_bind_param($stmt, "is", $idUsuario, $tabla);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $tienePermiso);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);
    return $tienePermiso;
}
?>
