<?php
error_reporting(E_ALL ^ E_NOTICE);
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST, PUT, GET, DELETE, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");
header("Content-Type: application/json");

include_once '../conexion.php';

try {
    $bodyRequest = file_get_contents("php://input");
        // Iniciar transacción
    mysqli_begin_transaction($conn);
    $nombre_tabla = 'Produccion';
    $tipo_permiso = 'insertar';
    
    if ($bodyRequest === false) {
        throw new Exception("Error al leer los datos de la solicitud.", 400);
    }

    // Verificar si se enviaron datos en la solicitud
    if (empty($bodyRequest)) {
        throw new Exception("No se han enviado datos en la solicitud.", 400);
    }

    // Decodificar los datos JSON
    $datos = json_decode($bodyRequest, true);
    if ($datos === null) {
        throw new Exception("Error al decodificar los datos JSON.", 400);
    }

    // Verificar si se proporciono el campo Nombre_Sucursal y token
    if (!isset($datos['Detalle'], $datos['token'])) {
         throw new Exception("Faltan datos requeridos.", 400);
    }

    // Verificar si el campo Nombre_Sucursal y token no está vacío y no consiste solo en espacios en blanco
    if (empty($datos['token']) ||  trim($datos['token']) === '') {
        throw new Exception("Campos vacíos o con espacios en blanco, llene datos para registro.", 400);
    }


    // Obtener otros datos del array
    $token = $datos['token'];
    $Fecha_Produccion = $datos['Fecha_emision'];
    $ID_Sucursal = $datos['ID_Sucursal'];
    $ID_Usuario = $datos['ID_Usuario'];
    $tipo_documento = mysqli_real_escape_string($conn, $datos['tipo_comprobanteSeleccionado']);
    $descripcion = mysqli_real_escape_string($conn, $datos['descripcion']);

    // Verificar autorizacion del usuario y permisos
    $id_usuario = obtenerIdUsuarioPorToken($conn, $token);
    if ($id_usuario === null) {
        throw new Exception("Token de autorizacion invalido.", 401);
    }

    $permiso = tienePermiso($conn, $id_usuario, $nombre_tabla, $tipo_permiso);
    if ($permiso === null) {
        throw new Exception("El usuario no tiene permisos para esta tabla.", 403);
    } elseif (!$permiso) {
        throw new Exception("El usuario no tiene permisos para editar en esta tabla.", 403);
    }

        $query = "SELECT numero,serie FROM correlativo_sucursal_BFN WHERE ID_Sucursal = '$ID_Sucursal' AND tipo_documento = '$tipo_documento' FOR UPDATE";
        $result = mysqli_query($conn, $query);
        $row = mysqli_fetch_assoc($result);
        $numeroActual = $row['numero'];
        $serie = $row['serie'];

        // Incrementar el numero actual en 1
        $numeroNuevo = $numeroActual + 1;

        // Actualizar el numero en la tabla correlativo_sucursal_BFN
        $queryUpdate = "UPDATE correlativo_sucursal_BFN SET numero = $numeroNuevo WHERE ID_Sucursal = '$ID_Sucursal' AND tipo_documento= '$tipo_documento'";
        if (!mysqli_query($conn, $queryUpdate)) {
            throw new Exception(mysqli_error($conn));
        }

        // Formatear el numero nuevo con ceros a la izquierda
        $numeroFormateado = str_pad($numeroNuevo, 8, '0', STR_PAD_LEFT);

        // Usar el numero formateado como nrocomprobante
        $nroComprobante = $serie . '-' . $numeroFormateado;
        $nroComprobantee = $serie . '-' . $numeroFormateado;
        
        
            $sql_insert_cabecera = "INSERT INTO `Cabecera_produccion` (`ID_Sucursal`, `ID_Usuario`, `NroComprobante`, `Fecha_emision`, `Descripcion`) VALUES
            ('$ID_Sucursal','$ID_Usuario','$nroComprobante','$Fecha_Produccion','$descripcion')";

            if (!mysqli_query($conn, $sql_insert_cabecera)) {
                throw new Exception("Error al guardar los datos de la cabecera de la Cabecera_produccion: " . mysqli_error($conn));
            }
    
    $id_venta = mysqli_insert_id($conn);
        
        

    // Construir y ejecutar la consulta SQL
    foreach ($datos['Detalle'] as $detalle) {
        $ID_Receta = mysqli_real_escape_string($conn, $detalle['ID_Receta']);
        $Cantidad_Producida = mysqli_real_escape_string($conn, $detalle['Cantidad_Vendida']);
        $ID_Producto = mysqli_real_escape_string($conn, $detalle['ID_Producto']);
    
        $sql_insert_detalle = "INSERT INTO Produccion(IDcabecera_Produccion, Fecha_Produccion, ID_Receta, Cantidad_Producida, ID_Producto, ID_Sucursal) VALUES
        ('$id_venta','$Fecha_Produccion', '$ID_Receta', '$Cantidad_Producida', '$ID_Producto', '$ID_Sucursal')";
    
        if (!mysqli_query($conn, $sql_insert_detalle)) {
            throw new Exception("Error al guardar los datos del detalle de la Produccion: " . mysqli_error($conn));
        }
    
        // Actualizar el stock de insumos en la sucursal
       /* $sql_actualizar_stock = "UPDATE Stock_Insumos_Sucursal sis 
                                 JOIN Recetas_Insumos ri ON sis.ID_Insumo = ri.ID_Insumo 
                                 SET sis.Cantidad = sis.Cantidad - (ri.Cantidad_Usada * '$Cantidad_Producida') 
                                 WHERE ri.ID_Receta = '$ID_Receta'";
                                 
      */     
      
      
                                   /*  $sql_actualizar_stock = "UPDATE Stock_Insumos_Sucursal AS sis
                                    JOIN (
                                        SELECT ID_Insumo, SUM(Cantidad_Usada * '$Cantidad_Producida') AS Cantidad_Restar
                                        FROM Recetas_Insumos
                                        WHERE ID_Receta = '$ID_Receta'
                                        GROUP BY ID_Insumo
                                    ) AS ri ON sis.ID_Insumo = ri.ID_Insumo
                                    SET sis.Cantidad = sis.Cantidad - ri.Cantidad_Restar
                                    WHERE sis.ID_Sucursal =$ID_Sucursal;";
                                 
    
        if (!mysqli_query($conn, $sql_actualizar_stock)) {
            throw new Exception("Error al actualizar el stock de insumos en la sucursal: " . mysqli_error($conn));
        }
        */
    }

    mysqli_stmt_close($stmt);
    
    // Confirmar la transaccion
    mysqli_commit($conn);
    $resultado['COMPROBANTE'] = $nroComprobante;
    $resultado['ESTADO'] = "1";
    $resultado['MENSAJE'] = "La informacion se registro correctamente";
    $resultado['CODIGO'] = "200";
 
} catch (Exception $e) {
    // En caso de error, hacer rollback de la transaccion
    mysqli_rollback($conn);
    $resultado['COMPROBANTE'] ='0';
    $resultado['ESTADO'] = "0";
    $resultado['MENSAJE'] = $e->getMessage();
    $resultado['CODIGO'] = $e->getCode();
}

// Imprimir respuesta en formato JSON
print_json($resultado);
mysqli_close($conn);

// Funcion para imprimir respuesta en formato JSON
function print_json($data) {
    header("HTTP/1.1");
    header("Content-Type: application/json; charset=UTF-8");
    echo json_encode($data, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE);
}

// Funcion para obtener el ID de usuario por token
function obtenerIdUsuarioPorToken($conn, $token) {
    $sql = "SELECT id_usuario FROM sesiones WHERE token = ?";
    $stmt = mysqli_prepare($conn, $sql);
    mysqli_stmt_bind_param($stmt, "s", $token);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $idUsuario);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);
    return $idUsuario;
}

// Funcion para verificar si el usuario tiene permisos
function tienePermiso($conn, $idUsuario, $tabla, $tipo_permiso_usuario) {
    $sql = "SELECT $tipo_permiso_usuario FROM permisos WHERE id_usuario = ? AND tabla = ?";
    $stmt = mysqli_prepare($conn, $sql);
    mysqli_stmt_bind_param($stmt, "is", $idUsuario, $tabla);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $tienePermiso);
    mysqli_stmt_fetch($stmt);
    mysqli_stmt_close($stmt);
    return $tienePermiso;
}
?>
