<?php
error_reporting(E_ALL ^ E_NOTICE);
// Permite solicitudes desde http://localhost:4200
//header("Access-Control-Allow-Origin: http://localhost:4200");
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST, PUT, GET, DELETE, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");

// Si la solicitud es de tipo OPTIONS, responde con los encabezados CORS y termina la ejecución
if ($_SERVER['REQUEST_METHOD'] === 'OPTIONS') {
    header("HTTP/1.1 200 OK");
    exit;
}



$json_data = file_get_contents('php://input');

// Decodificar los datos JSON en un array asociativo
$data = json_decode($json_data, true);

// Verificar si se recibieron datos
if (empty($data)) {
    // Datos vacíos, enviar respuesta de error
    http_response_code(400);
    echo json_encode(array("status" => "error", "message" => "No se recibieron datos"));
    exit;
}

// URL de la API de Google Apps Script
$url = 'https://script.google.com/macros/s/AKfycbwBPAJcKdqrukloLFswKeey05oSjZKqkogQ46y0pMahJQIXQI2hl9wieB34qXwB3iIioQ/exec';

// Codificar los datos como JSON nuevamente
$postData = json_encode($data);

// Configurar las opciones de la solicitud
$options = array(
    'http' => array(
        'method' => 'POST',
        'header' => 'Content-Type: application/json',
        'content' => $postData
    )
);

// Crear el contexto de la solicitud
$context = stream_context_create($options);

// Realizar la solicitud a la URL de la API de Google Apps Script
$result = file_get_contents($url, false, $context);

// Verificar si la solicitud fue exitosa
if ($result === false) {
    // Manejar el error
    http_response_code(500);
    echo json_encode(array("status" => "error", "message" => "Error al realizar la solicitud a la API de Google Apps Script"));
} else {
    // Retornar la respuesta de la API de Google Apps Script
    // También incluir un mensaje de éxito
    echo json_encode(json_decode($result));
}
?>
