<?php
error_reporting(E_ALL ^ E_NOTICE);
header("Access-Control-Allow-Origin: *");
header("Access-Control-Allow-Methods: POST, PUT, GET, DELETE, OPTIONS");
header("Access-Control-Allow-Headers: Content-Type");
header("Content-Type: application/json");

include_once '../conexion.php';
include_once 'pdf.php';

try {
    $bodyRequest = file_get_contents("php://input");
    
    // Iniciar transacción
    mysqli_begin_transaction($conn);
    
    $nombre_tabla = 'Cabecera_Ventas';
    $tipo_permiso = 'insertar';
    
      $valor_limite = 0;
      $totalvendidos = 0;
      $valorventaactual = 0;
      
    if ($bodyRequest === false) {
        throw new Exception("Error al leer los datos de la solicitud.", 400);
    }

    // Verificar si se enviaron datos en la solicitud
    if (empty($bodyRequest)) {
        throw new Exception("No se han enviado datos en la solicitud.", 400);
    }

    // Decodificar los datos JSON
    $datos = json_decode($bodyRequest, true);
    if ($datos === null) {
        throw new Exception("Error al decodificar los datos JSON.", 400);
    }

    // Verificar si se proporciono el campo Nombre_Sucursal y token
    if (!isset($datos['ID_Sucursal'], $datos['Fecha_Venta'], $datos['ID_Cliente'], $datos['Detalle'], $datos['token'])) {
         throw new Exception("Faltan datos requeridos.", 400);
    }

    // Verificar si el campo Nombre_Sucursal y token no está vacío y no consiste solo en espacios en blanco
    if (empty($datos['ID_Sucursal']) || empty($datos['token']) || empty($datos['ID_Cliente']) || trim($datos['token']) === '') {
        throw new Exception("Campos vacíos o con espacios en blanco, llene datos para registro.", 400);
    }


    // Obtener otros datos del array
    $token = $datos['token'];
    $HoraVenta = mysqli_real_escape_string($conn, $datos['HoraVenta']);
    $Fecha_Venta = mysqli_real_escape_string($conn, $datos['Fecha_Venta']);
    $Fechaemision = mysqli_real_escape_string($conn, $datos['Fechaemision']);
    $Fechavence = mysqli_real_escape_string($conn, $datos['Fechavence']);
    $ID_Cliente = mysqli_real_escape_string($conn, $datos['ID_Cliente']);
    $ID_Metodo_Pago = mysqli_real_escape_string($conn, $datos['ID_Metodo_Pago']);
    $ID_Metodo_Pago1 = mysqli_real_escape_string($conn, $datos['ID_Metodo_Pago1']);
    $ID_Sucursal = mysqli_real_escape_string($conn, $datos['ID_Sucursal']);
    $ID_Usuario = mysqli_real_escape_string($conn, $datos['ID_Usuario']);
    $ID_Moneda = mysqli_real_escape_string($conn, $datos['ID_Moneda']);
    $simbolomoneda= mysqli_real_escape_string($conn, $datos['simbolomoneda']);
    
    //$tipo_documento= mysqli_real_escape_string($conn, $datos['tipo_documento']);
    $tipo_documento_cliente = mysqli_real_escape_string($conn, $datos['tipo_documento']);
    
    $Estado_Entrega= mysqli_real_escape_string($conn, $datos['Estado_Entrega']);
    $Estado_Prestamo= mysqli_real_escape_string($conn, $datos['Estado_Prestamo']); 
    $Tipo_Proceso= mysqli_real_escape_string($conn, $datos['Tipo_Proceso']); 
    $Estado_Activo = '1';
    $Estado_Canje = '0'; //
    $Tipo_OperacionCaja = 'Venta : ';

    $Tipo_Operacion= mysqli_real_escape_string($conn, $datos['Tipo_Operacion']);
    $Total_Grabadas= mysqli_real_escape_string($conn, $datos['Total_Grabadas']);
    $Total_Inafecta= mysqli_real_escape_string($conn, $datos['Total_Inafecta']);
    $Total_Exoneradas= mysqli_real_escape_string($conn, $datos['Total_Exoneradas']);
    $Total_Gratuitas= mysqli_real_escape_string($conn, $datos['Total_Gratuitas']);
    
    $Subtotal_percepciones= mysqli_real_escape_string($conn, $datos['Subtotal_percepciones']);
    $Porcentaje_percepciones= mysqli_real_escape_string($conn, $datos['Porcentaje_percepciones']);
    $BI_percepciones= mysqli_real_escape_string($conn, $datos['BI_percepciones']);
    $Total_Percepciones= mysqli_real_escape_string($conn, $datos['Total_Percepciones']);
    
    $Porcentaje_retenciones= mysqli_real_escape_string($conn, $datos['Porcentaje_retenciones']);
    $BI_retenciones= mysqli_real_escape_string($conn, $datos['BI_retenciones']);
    $Total_Retenciones= mysqli_real_escape_string($conn, $datos['Total_Retenciones']);
    
    
    $Cod_Medio_Pago= mysqli_real_escape_string($conn, $datos['Cod_Medio_Pago']);
    $Cuenta_Bancaria= mysqli_real_escape_string($conn, $datos['Cuenta_Bancaria']);
    $Cod_Detraccion= mysqli_real_escape_string($conn, $datos['Cod_Detraccion']);
    $Por_Detraccion= mysqli_real_escape_string($conn, $datos['Por_Detraccion']);
    $Total_Detracciones= mysqli_real_escape_string($conn, $datos['Total_Detracciones']);
    $Total_Descuento= mysqli_real_escape_string($conn, $datos['Total_Descuento']);
    $Sub_Total= mysqli_real_escape_string($conn, $datos['Sub_Total']);
    $Porcentaje_IGV= mysqli_real_escape_string($conn, $datos['Porcentaje_IGV']);
    $Total_IGV= mysqli_real_escape_string($conn, $datos['Total_IGV']);
    $Forma_Pago= mysqli_real_escape_string($conn, $datos['Forma_Pago']);
    $Total_ISC= mysqli_real_escape_string($conn, $datos['Total_ISC']);
    $Total_ICBPER= mysqli_real_escape_string($conn, $datos['Total_ICBPER']);
    $Total_Impuestos= mysqli_real_escape_string($conn, $datos['Total_Impuestos']);
    $Total_Otrs_Ompuestos= mysqli_real_escape_string($conn, $datos['Total_Otrs_Ompuestos']);
    $Total= mysqli_real_escape_string($conn, $datos['Total']);
    $Nro_Guia_Remision= mysqli_real_escape_string($conn, $datos['Nro_Guia_Remision']);
    $Cod_Guia_Gemision= mysqli_real_escape_string($conn, $datos['Cod_Guia_Gemision']);
    $Nro_Otro_Comprobante= mysqli_real_escape_string($conn, $datos['Nro_Otro_Comprobante']);
    $Cod_Otro_Comprobante= mysqli_real_escape_string($conn, $datos['Cod_Otro_Comprobante']);
    $Cod_Tipo_Documento= mysqli_real_escape_string($conn, $datos['Cod_Tipo_Documento']);
    $Codigo_Leyenda= mysqli_real_escape_string($conn, $datos['Codigo_Leyenda']);
    $Descripcion_Leyenda= mysqli_real_escape_string($conn, $datos['Descripcion_Leyenda']);
    $Tipo_Doc_Cliente= mysqli_real_escape_string($conn, $datos['Tipo_Doc_Cliente']);
    $Ubigeo_Cliente= mysqli_real_escape_string($conn, $datos['Ubigeo_Cliente']);
    $Cod_Pais_Cliente= mysqli_real_escape_string($conn, $datos['Cod_Pais_Cliente']);
    $Cod_Sunat= mysqli_real_escape_string($conn, $datos['Cod_Sunat']);
    $Mensaje_Sunat= mysqli_real_escape_string($conn, $datos['Mensaje_Sunat']);
    $Hash_Cpe= mysqli_real_escape_string($conn, $datos['Hash_Cpe']);
    $Observacion= mysqli_real_escape_string($conn, $datos['Observacion']);

    $Ruccliente= mysqli_real_escape_string($conn, $datos['Ruccliente']);
    $NombreCliente= mysqli_real_escape_string($conn, $datos['NombreCliente']);
    $DireccionCliente= mysqli_real_escape_string($conn, $datos['DireccionCliente']);
    $TotalLetras= mysqli_real_escape_string($conn, $datos['TotalLetras']);

    $EmpresaRuc= mysqli_real_escape_string($conn, $datos['EmpresaRuc']);
    $EmpresaRazonsocial= mysqli_real_escape_string($conn, $datos['EmpresaRazonsocial']);
    $EmpresaDireccion= mysqli_real_escape_string($conn, $datos['EmpresaDireccion']);
    $EmpresaTelefono= mysqli_real_escape_string($conn, $datos['EmpresaTelefono']);
    $EmpresaCorreo= mysqli_real_escape_string($conn, $datos['EmpresaCorreo']);
    
    $restastock= mysqli_real_escape_string($conn, $datos['restastock']);

    $Acuenta= mysqli_real_escape_string($conn, $datos['Acuenta']);
    $Pendiente= mysqli_real_escape_string($conn, $datos['Pendiente']);
    
    $Fecha_inicio = date('Y-m-01');
    $Fecha_fin = date('Y-m-t');
        
	// Comprobar el tipo de documento y asignar un valor correspondiente 
	if (strpos($tipo_documento_cliente, 'BOLETA') !== false) {
	    $tipo_documento = 'BOLETA';
	} elseif (strpos($tipo_documento_cliente, 'FACTURA') !== false) {
	    $tipo_documento = 'FACTURA';
	} elseif (strpos($tipo_documento_cliente, 'NOTA') !== false || strpos($tipo_documento_cliente, 'RECIBO') !== false || strpos($tipo_documento_cliente, 'TICKET') !== false) {
	    $tipo_documento = 'NOTA';
	} else {
	    $tipo_documento = 'OTRO';
	}


    // Verificar autorizacion del usuario y permisos
    $id_usuario = obtenerIdUsuarioPorToken($conn, $token);
    if ($id_usuario === null) {
        throw new Exception("Token de autorizacion invalido.", 401);
    }

    $permiso = tienePermiso($conn, $id_usuario, $nombre_tabla, $tipo_permiso);
    if ($permiso === null) {
        throw new Exception("El usuario no tiene permisos para esta tabla.", 403);
    } elseif (!$permiso) {
        throw new Exception("El usuario no tiene permisos para editar en esta tabla.", 403);
    }

if ($tipo_documento != 'NOTA') {
    // Consulta SQL para obtener el límite de monto de la empresa
    $sql1 = "SELECT limite_monto FROM Empresa";
    $stmt1 = mysqli_prepare($conn, $sql1);
    if (!$stmt1) {
        throw new Exception("Error al preparar la consulta para obtener el límite de monto de la empresa: " . mysqli_error($conn));
    }
    mysqli_stmt_execute($stmt1);
    mysqli_stmt_bind_result($stmt1, $valor_limite);
    mysqli_stmt_fetch($stmt1);
    mysqli_stmt_close($stmt1);

    // Consulta SQL para obtener el total de ventas vigentes
    $sql2 = "SELECT SUM(Total) AS total_ventas_vigentes FROM Cabecera_Ventas WHERE Estado_Activo=1 AND Estado_Canje=0 AND Fecha_Venta BETWEEN ? AND ?";
    $stmt2 = mysqli_prepare($conn, $sql2);
    if (!$stmt2) {
        throw new Exception("Error al preparar la consulta para obtener el total de ventas vigentes: " . mysqli_error($conn));
    }
    mysqli_stmt_bind_param($stmt2, "ss", $Fecha_inicio, $Fecha_fin);
    mysqli_stmt_execute($stmt2);
    mysqli_stmt_bind_result($stmt2, $totalvendidos);
    mysqli_stmt_fetch($stmt2);
    mysqli_stmt_close($stmt2);

    $valorventaactual = $valor_limite - $totalvendidos;

    if ($valorventaactual < $Total) {
        throw new Exception("Ha superado el límite de ventas en su regimen " . $valorventaactual . ". Límite actual: " . $valor_limite, 400);
    }
}



        $query = "SELECT numero,serie FROM correlativo_sucursal_BFN WHERE ID_Sucursal = '$ID_Sucursal' AND tipo_documento = '$tipo_documento' FOR UPDATE";
        $result = mysqli_query($conn, $query);
        $row = mysqli_fetch_assoc($result);
        $numeroActual = $row['numero'];
        $serie = $row['serie'];

        // Incrementar el numero actual en 1
        $numeroNuevo = $numeroActual + 1;

        // Actualizar el numero en la tabla correlativo_sucursal_BFN
        $queryUpdate = "UPDATE correlativo_sucursal_BFN SET numero = $numeroNuevo WHERE ID_Sucursal = '$ID_Sucursal' AND tipo_documento= '$tipo_documento'";
        if (!mysqli_query($conn, $queryUpdate)) {
            throw new Exception(mysqli_error($conn));
        }

        // Formatear el numero nuevo con ceros a la izquierda
        $numeroFormateado = str_pad($numeroNuevo, 8, '0', STR_PAD_LEFT);

        // Usar el numero formateado como nrocomprobante
        $nroComprobante = $serie . '-' . $numeroFormateado;
        $nroComprobantee = $serie . '-' . $numeroFormateado;

   $sql = "UPDATE caja SET monto_cierre = monto_cierre + '$Total' WHERE usuario_id = '$ID_Usuario' AND estado_cierre = 'Caja Abierta' AND sucursal_id = '$ID_Sucursal'";
        if (!mysqli_query($conn, $sql)) {
        throw new Exception("Error al actualizar caja: " . mysqli_error($conn));
    }
    
    /*$sql_insert_movimientocaja = "INSERT INTO Movimientos_Caja(ID_Usuario, ID_Sucursal, Tipo_Operacion, Monto, Fecha, Hora) VALUES (
    '$ID_Usuario','$ID_Sucursal','$Tipo_OperacionCaja, $nroComprobante','$Total','$Fecha_Venta', '$HoraVenta')";

    if (!mysqli_query($conn, $sql_insert_movimientocaja)) {
        throw new Exception("Error al guardar los datos de la cabecera de la sql_insert_movimientocaja: " . mysqli_error($conn));
    }*/
    
    $sql_insert_cabecera = "INSERT INTO `Cabecera_Ventas` (`ID_Cliente`, `ID_Metodo_Pago`, `ID_Sucursal`, `ID_Usuario`, `ID_Moneda`, `SerieComprobante`,
    `NroComprobante`, `Estado_Activo`, `Estado_Entrega`, `Estado_Canje`, `Estado_Prestamo`,  `Tipo_Proceso`, `Tipo_Operacion`, `HoraVenta`, `Fecha_Venta`, `Fechaemision`, `Fechavence`,
    `Total_Grabadas`, `Total_Inafecta`, `Total_Exoneradas`, `Total_Gratuitas`, `Subtotal_percepciones`, `Porcentaje_percepciones`, `BI_percepciones`, `Total_Percepciones`, `Porcentaje_retenciones`,`BI_retenciones`,`Total_Retenciones`, `Cod_Medio_Pago`, `Cuenta_Bancaria`, `Cod_Detraccion`,
    `Por_Detraccion`, `Total_Detracciones`, `Total_Descuento`, `Sub_Total`, `Porcentaje_IGV`, `Total_IGV`, `Forma_Pago`, `Total_ISC`, `Total_ICBPER`, `Total_Impuestos`, 
    `Total_Otrs_Ompuestos`, `Total`, `Nro_Guia_Remision`, `Cod_Guia_Gemision`, `Nro_Otro_Comprobante`, `Cod_Otro_Comprobante`, `Cod_Tipo_Documento`, `Codigo_Leyenda`,
    `Descripcion_Leyenda`, `Tipo_Doc_Cliente`, `Ubigeo_Cliente`, `Cod_Pais_Cliente`, `Cod_Sunat`, `Mensaje_Sunat`, `Hash_Cpe`, `Observacion`) 
    VALUES 
    ('$ID_Cliente','$ID_Metodo_Pago',
    '$ID_Sucursal','$ID_Usuario','$ID_Moneda','$serie','$numeroFormateado','$Estado_Activo','$Estado_Entrega','$Estado_Canje','$Estado_Prestamo','$Tipo_Proceso','$Tipo_Operacion','$HoraVenta',
    '$Fecha_Venta','$Fechaemision','$Fechavence','$Total_Grabadas','$Total_Inafecta','$Total_Exoneradas','$Total_Gratuitas','$Subtotal_percepciones','$Porcentaje_percepciones','$BI_percepciones','$Total_Percepciones','$Porcentaje_retenciones','$BI_retenciones','$Total_Retenciones','$Cod_Medio_Pago','$Cuenta_Bancaria','$Cod_Detraccion',
    '$Por_Detraccion','$Total_Detracciones','$Total_Descuento','$Sub_Total','$Porcentaje_IGV','$Total_IGV','$Forma_Pago','$Total_ISC','$Total_ICBPER','$Total_Impuestos',
    '$Total_Otrs_Ompuestos','$Total','$Nro_Guia_Remision','$Cod_Guia_Gemision','$Nro_Otro_Comprobante','$Cod_Otro_Comprobante','$Cod_Tipo_Documento','$Codigo_Leyenda',
    '$Descripcion_Leyenda','$Tipo_Doc_Cliente','$Ubigeo_Cliente','$Cod_Pais_Cliente','$Cod_Sunat','$Mensaje_Sunat','$Hash_Cpe',$Observacion)";

    if (!mysqli_query($conn, $sql_insert_cabecera)) {
        throw new Exception("Error al guardar los datos de la cabecera de la Cabecera_Ventas: " . mysqli_error($conn));
    }
    
    $id_venta = mysqli_insert_id($conn);
        
    
    foreach ($datos['Metodos_Pago'] as $metodopago) {
      $ID_Metodo_Pago = $metodopago['ID_Metodo_Pago'];
      $Monto_Pagado = $metodopago['Monto_Pagado']; //

        $sql_insert_metodopagoventa= "INSERT INTO `Metodo_Pagoventa` (`ID_Venta`, `ID_Metodo_Pago`, `Monto_Pagado`) 
        VALUES 
        ('$id_venta','$ID_Metodo_Pago','$Monto_Pagado')";
    
        if (!mysqli_query($conn, $sql_insert_metodopagoventa)) {
            throw new Exception("Error al guardar los datos de la cabecera de la metodo pago venta: " . mysqli_error($conn));
        }
    }


if($Forma_Pago=="0"){
    $sql_insert_Cabecera_CreditoVentas = "INSERT INTO `Cabecera_CreditoVentas` (`ID_Venta`,`ID_Sucursal`, `ID_Usuario`,`Estado_Cancelado`, `Fecha_vence`, `Total`, `Acuenta`, `Pendiente`)VALUES 
    ('$id_venta','$ID_Sucursal','$ID_Usuario','0','$Fechavence','$Total','$Acuenta','$Pendiente')";

    if (!mysqli_query($conn, $sql_insert_Cabecera_CreditoVentas)) {
        throw new Exception("Error al guardar los datos de la cabecera de la Cabecera_CreditoVentas: " . mysqli_error($conn));
    }
    
    $id_caventa = mysqli_insert_id($conn);
    
    foreach ($datos['cuotas'] as $cuotas) {
      $COD_FORMA_PAGO = $cuotas['COD_FORMA_PAGO'];
      $MONTO_FORMA_PAGO = $cuotas['MONTO_FORMA_PAGO'];
      $FECHA_FORMA_PAGO = $cuotas['FECHA_FORMA_PAGO'];

        $sql_insert_metodopagoventa= "INSERT INTO `Detalle_VentasCredito` (`ID_Cab_CreditoV`, `Fecha_emision`, `COD_FORMA_PAGO`, `MONTO_FORMA_PAGO`, `FECHA_FORMA_PAGO`) 
        VALUES 
        ('$id_caventa','$Fecha_Venta','$COD_FORMA_PAGO','$MONTO_FORMA_PAGO','$FECHA_FORMA_PAGO')";
    
        if (!mysqli_query($conn, $sql_insert_metodopagoventa)) {
            throw new Exception("Error al guardar los datos de la cabecera de la metodo pago venta: " . mysqli_error($conn));
        }
    }
}

    

    foreach ($datos['Detalle'] as $detalle) {
        $ID_Venta = mysqli_real_escape_string($conn, $detalle['ID_Venta']);
        $ID_Producto = mysqli_real_escape_string($conn, $detalle['ID_Producto']);
        $Cantidad_Vendida = mysqli_real_escape_string($conn, $detalle['Cantidad_Vendida']);
        $Precio_Unitario = mysqli_real_escape_string($conn, $detalle['Precio_Unitario']);
        $Importe = mysqli_real_escape_string($conn, $detalle['Importe']); 
        $P_snimpuesto = mysqli_real_escape_string($conn, $detalle['P_snimpuesto']); 
        $IGV_Peru = mysqli_real_escape_string($conn, $detalle['IGV_Peru']); 
        $IGV_5 = mysqli_real_escape_string($conn, $detalle['IGV_5']); 
        $IGV_10 = mysqli_real_escape_string($conn, $detalle['IGV_10']); 
        $EXE = mysqli_real_escape_string($conn, $detalle['EXE']); 
        $EXO = mysqli_real_escape_string($conn, $detalle['EXO']); 
        $Grab5 = mysqli_real_escape_string($conn, $detalle['Grab5']); 
        $Grab10 = mysqli_real_escape_string($conn, $detalle['Grab10']); 
        $GrabE = mysqli_real_escape_string($conn, $detalle['GrabE']); 
        $Total = mysqli_real_escape_string($conn, $detalle['Total']); 
        $Exonerados = mysqli_real_escape_string($conn, $detalle['Exonerados']); 
        $Bonificacion = mysqli_real_escape_string($conn, $detalle['Bonificacion']); 
        $Gratuita = mysqli_real_escape_string($conn, $detalle['Gratuita']); 
        $Bolsa = mysqli_real_escape_string($conn, $detalle['Bolsa']); 
        $Valor_impuesto_a_la_bolsa = mysqli_real_escape_string($conn, $detalle['Valor_impuesto_a_la_bolsa']); 
        $TOTAL_ICBPER = mysqli_real_escape_string($conn, $detalle['TOTAL_ICBPER']); 
        $Observacion = mysqli_real_escape_string($conn, $detalle['Observacion']); 
        $Estado_Activo = mysqli_real_escape_string($conn, $detalle['Estado_Activo']); 
        $Cantidad_Entrega = mysqli_real_escape_string($conn, $detalle['Cantidad_Entrega']); 
        $Estado_Entrega = mysqli_real_escape_string($conn, $detalle['Estado_Entrega']); 

        
        $sql_insert_detalle = "INSERT INTO `Detalle_Ventas` (`ID_Venta`, `ID_Producto`, `ID_Sucursal`, `ID_Usuario`, `Cantidad_Vendida`, `Precio_Unitario`, `Importe`, `P_snimpuesto`, `IGV_Peru`, `IGV_5`, `IGV_10`, `EXE`, `EXO`, `Grab5`, `Grab10`, `GrabE`, `Total`, `Exonerados`, `Bonificacion`, `Gratuita`, `Bolsa`, `Valor_impuesto_a_la_bolsa`, `TOTAL_ICBPER`, `Observacion`, `Estado_Activo`, `Cantidad_Entrega`, `Estado_Entrega`, `restastock`) VALUES (
                                                                                 '$id_venta', '$ID_Producto', '$ID_Sucursal','$ID_Usuario', '$Cantidad_Vendida', '$Precio_Unitario', '$Importe', '$P_snimpuesto', '$IGV_Peru', '$IGV_5', '$IGV_10', 
                                                                                 '$EXE', '$EXO', '$Grab5', '$Grab10', '$GrabE', '$Total', '$Exonerados', '$Bonificacion', '$Gratuita', '$Bolsa', '$Valor_impuesto_a_la_bolsa', '$TOTAL_ICBPER', '$Observacion', '$Estado_Activo', '$Cantidad_Entrega', '$Estado_Entrega','$restastock')";
/*
$sql_insert_detalle = "INSERT INTO `Detalle_Ventas` (`ID_Venta`, `ID_Producto`, `ID_Sucursal`, `Cantidad_Vendida`, `Precio_Unitario`, `Importe`, `P_snimpuesto`, `IGV_Peru`, `IGV_5`, `IGV_10`, `EXE`, `EXO`, `Grab5`, `Grab10`, `GrabE`, `Total`, `Exonerados`, `Bonificacion`, `Gratuita`, `Bolsa`, `Valor_impuesto_a_la_bolsa`, `TOTAL_ICBPER`, `Observacion`, `Estado_Activo`, `Cantidad_Entrega`, `Estado_Entrega`, `restastock`) VALUES (
'$id_venta', '$ID_Producto', '$ID_Sucursal', '$Cantidad_Vendida', '$Precio_Unitario', '$Importe', '$P_snimpuesto', '$IGV_Peru', '$IGV_5', '$IGV_10', 
'$EXE', '$EXO', '$Grab5', '$Grab10', '$GrabE', '$Total', '$Exonerados', '$Bonificacion', '$Gratuita', '$Bolsa', '$Valor_impuesto_a_la_bolsa', '$TOTAL_ICBPER', '$Observacion', '$Estado_Activo', '$Cantidad_Entrega', '$Estado_Entrega','$restastock')";
*/
 
 
        if (!mysqli_query($conn, $sql_insert_detalle)) {
            throw new Exception("Error al guardar los datos del detalle de la venta: " . mysqli_error($conn));
        }
        
        /// funciona por trigger
        /* $sql_incrementar_cantidad = "UPDATE `StockProductos_PorSucursal` SET `Stock` =`Stock` - $Cantidad_Vendida WHERE `StockProductos_PorSucursal`.`ID_Producto` = $ID_Producto AND ID_Sucursal = $ID_Sucursal ;";
        if (!mysqli_query($conn, $sql_incrementar_cantidad)) {
            throw new Exception("Error al incrementar la cantidad en Stock_Insumos_Sucursal: " . mysqli_error($conn));
        }*/
        
    }
    
// Agregar el número de comprobante al array $datos
$datos['nroComprobante'] = $nroComprobante;

// Llamar a la función generarPDF con los datos actualizados
$pdfPath = generarPDF($datos);

    
    //mysqli_stmt_close($conn,$stmt);
    // Confirmar la transaccion
    mysqli_commit($conn);

    $resultado['ESTADO'] = "1";
    $resultado['COMPROBANTE'] = $nroComprobante;
    $resultado['IDVENTA'] = $id_venta;
    $resultado['MENSAJE'] = "La informacion se registro correctamente";
    $resultado['CODIGO'] = "200";
 
} catch (Exception $e) {
    // En caso de error, hacer rollback de la transaccion
    mysqli_rollback($conn);
    
    $resultado['ESTADO'] = "0";
    $resultado['COMPROBANTE'] = "0";
    $resultado['IDVENTA'] = "0";
    $resultado['MENSAJE'] = $e->getMessage();
    $resultado['CODIGO'] = $e->getCode();
}

// Imprimir respuesta en formato JSON
print_json($resultado);
mysqli_close($conn);

// Funcion para imprimir respuesta en formato JSON
function print_json($data) {
    header("HTTP/1.1");
    header("Content-Type: application/json; charset=UTF-8");
    echo json_encode($data, JSON_PRETTY_PRINT | JSON_UNESCAPED_UNICODE);
}

// Funcion para obtener el ID de usuario por token
function obtenerIdUsuarioPorToken($conn, $token) {
    $sql = "SELECT id_usuario FROM sesiones WHERE token = ?";
    $stmt = mysqli_prepare($conn, $sql);
    mysqli_stmt_bind_param($stmt, "s", $token);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $idUsuario);
    mysqli_stmt_fetch($stmt);
   // mysqli_stmt_close($stmt);
    return $idUsuario;
}

// Funcion para verificar si el usuario tiene permisos
function tienePermiso($conn, $idUsuario, $tabla, $tipo_permiso_usuario) {
    $sql = "SELECT $tipo_permiso_usuario FROM permisos WHERE id_usuario = ? AND tabla = ?";
    $stmt = mysqli_prepare($conn, $sql);
    mysqli_stmt_bind_param($stmt, "is", $idUsuario, $tabla);
    mysqli_stmt_execute($stmt);
    mysqli_stmt_bind_result($stmt, $tienePermiso);
    mysqli_stmt_fetch($stmt);
   // mysqli_stmt_close($stmt);
    return $tienePermiso;
}
?>
